/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#include <stdafx.h>
#include <datacont.h>

CDataCont::CDataCont(void)
{
	m_szAccount     = NULL;
	m_szUser        = NULL;
	m_szPassword    = NULL;
	m_szProxyServer = NULL;
	m_fUseProxy     = false;

	InitializeCriticalSection(&m_csDataCont);
};

CDataCont::~CDataCont(void)
{
	DeleteCriticalSection(&m_csDataCont);
};

CDataCont* CDataCont::CreateObject()
{
	CDataCont* pObj = NULL;
	pObj = new CDataCont();
	return(pObj);
};

VOID CDataCont::SetAccount(LPTSTR szNew_)
{
	if(m_szAccount)
		delete[] m_szAccount;

	m_szAccount = new TCHAR[_tcslen(szNew_)+1];
	_tcscpy(m_szAccount, szNew_);

	cfdprintf(_T("CDataCont::SetAccount: %s"), m_szAccount);
};

VOID CDataCont::SetUser(LPTSTR szNew_)
{
	if(m_szUser)
		delete[] m_szUser;

	m_szUser = new TCHAR[_tcslen(szNew_)+1];
	_tcscpy(m_szUser, szNew_);

	cfdprintf(_T("CDataCont::SetUser: %s"), m_szUser);
};

VOID CDataCont::SetPassword(LPTSTR szNew_)
{
	if(m_szPassword)
		delete[] m_szPassword;

	m_szPassword = new TCHAR[_tcslen(szNew_)+1];
	_tcscpy(m_szPassword, szNew_);

	cfdprintf(_T("CDataCont::SetPassword: %s"), m_szPassword);
};

VOID CDataCont::SetData(LPTSTR szName_, LPTSTR szVal_)
{
	EnterCriticalSection(&m_csDataCont);
	m_mapDataCont[szName_] = szVal_;
	LeaveCriticalSection(&m_csDataCont);
};

LPTSTR CDataCont::GetData(LPTSTR szName_)
{
	LPTSTR szVal = NULL;
	LPTSTR szDupVal = NULL;
	STR2STRMAPIT it;

	EnterCriticalSection(&m_csDataCont);

	it = m_mapDataCont.find(szName_);
	if(it != m_mapDataCont.end())
	{
		szVal = (LPTSTR)it->second.c_str();
		szDupVal = new TCHAR[_tcslen(szVal)+1];
		_tcscpy(szDupVal, szVal);
	};
	
	LeaveCriticalSection(&m_csDataCont);

	return(szDupVal);
};

VOID CDataCont::SetUseProxy(BOOL fUse_)
{
	m_fUseProxy = fUse_;
};

VOID CDataCont::SetProxyServer(LPTSTR szNew_)
{
	if(m_szProxyServer)
		delete[] m_szProxyServer;

	m_szProxyServer = new TCHAR[_tcslen(szNew_)+1];
	_tcscpy(m_szProxyServer, szNew_);
};